<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2015 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBrealex
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_REALEX_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_REALEX_MODULE_ERR_PASS' );
    $password2_missing=JText::_( 'PMB_REALEX_MODULE_ERR_PASS2' );
    $vendor_name=trim($params->get('realex_user'));
    $vendor_password=trim($params->get('realex_password'));
    $vendor_password2=trim($params->get('realex_password2'));
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }
    /*
    else if($vendor_password2=='')
    {
      ? >
        <div class="pmb_error"><?php echo $password2_missing;? ></div>
      < ?php
      return false;
    }
    */
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {

    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }

    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('realex_trans_cost')+0;
    $percent_per_transaction=$params->get('realex_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('realex_user'));
    $vendor_password=trim($params->get('realex_password'));
    $vendor_password2=trim($params->get('realex_password2'));
    $language=$params->get('realex_language');
    $mode=$params->get('realex_mode');
    $currency=$params->get('realex_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'Realex');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'Realex');
    
    $languageCode=strtolower($language);
    if($languageCode!='en' && $languageCode!='pl')
    {
      $languageCode='en';
    }
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }

    $stamp=time();
    $amount=round($payment,2)*100;
    
    $realex_timestamp=date("YmdHms");
    
    $hash=$realex_timestamp.'.'.$vendor_name.'.'.$details['order_id'].'.'.$amount.'.'.$currency;
    $hash = sha1($hash);
    $hash=strtolower($hash);
		$hash = sha1($hash . '.' . $vendor_password);
    
    $realex_url="https://hpp.realexpayments.com/pay";
    if($mode=="TEST")
      $realex_url="https://hpp.sandbox.realexpayments.com/pay";
    
    $post_variables=array(
    "BILLING_CODE"=>$details['BillZip'],
    "BILLING_CO"=>$details['BillCountry'],
    "MERCHANT_ID"=>$vendor_name,
    "ORDER_ID"=>$details['order_id'],
    "AMOUNT"=>$amount,
    "CURRENCY"=>$currency,
    "TIMESTAMP"=>$realex_timestamp,
    "COMMENT1"=>$PaymentDescription,
    "COMMENT2"=>'paymybill-realex',
    "MERCHANT_RESPONSE_URL"=>JROUTE::_(JURI::root()."modules/mod_paymybill/return/realex_return.php"),
    "AUTO_SETTLE_FLAG"=>1,
    "SHA1HASH"=>$hash
    );
    if(trim($vendor_password2!=""))
    {
      $post_variables["ACCOUNT"]=$vendor_password2;
    }
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$realex_url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
?>